wm title . "Color Editor"

frame .menu -relief raised -borderwidth 2
frame .entryframe

scale .redscale -label Red -from 0 -to 255 -length 7c -orient horizontal -command newColor
scale .greenscale -label Green -from 0 -to 255 -length 7c -orient horizontal -command newColor
scale .bluescale -label Blue -from 0 -to 255 -length 7c -orient horizontal -command newColor

entry .entryframe.redentry -width 7
entry .entryframe.greenentry -width 7
entry .entryframe.blueentry -width 7
button .entryframe.setbutton -text set -command setColor

canvas .colorwin -width 7c -height 1.5c

menubutton .menu.file -text File -menu .menu.file.m -underline 0
menu .menu.file.m
.menu.file.m add command -label "Exit program" -underline 0 -command "destroy ."


pack .menu -side top -fill x
pack .menu.file -side left -fill x

pack .redscale .greenscale .bluescale -side top

pack .entryframe
pack .entryframe.redentry .entryframe.greenentry .entryframe.blueentry .entryframe.setbutton -side left

pack .colorwin -side bottom -pady 2m

proc newColor value {
   set color [format #%02x%02x%02x [.redscale get] [.greenscale get] [.bluescale get]]
   .colorwin config -background $color
}

proc setColor {} {
   .redscale set [.entryframe.redentry get]
   .greenscale set [.entryframe.greenentry get]
   .bluescale set [.entryframe.blueentry get]
}

