
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <signal.h>


#define MAXNTUBES      1000
#define MAXTUBELEGTH   1000
int ntubes, tubelength[MAXNTUBES];
float tubes[MAXNTUBES][MAXTUBELEGTH][3];
float tubevalue[MAXNTUBES][MAXTUBELEGTH];

int main(int argc, char* argv[])
{
  float radcent=0.9, radvert=1.3, radhoriz = 0.5;
  float pi2, dtheta,dphi,theta,cthe,sthe,phi,cphi,sphi;
  int i,j;

  pi2 = 2.0 * acos(-1);
  ntubes = 20;
  dtheta = pi2 / (float)(ntubes);

  printf("#ntubes          %d\n", ntubes);

  for(i=0; i<ntubes; i++) {
    tubelength[i] = 100;
    printf("#tubelength      %d\n", tubelength[i]);

    dphi = pi2 / (float)(tubelength[i]-1);
    theta = dtheta * (float)i;
    cthe = cos(theta);
    sthe = sin(theta);

    dphi   = pi2 / (float)tubelength[i];
    for(j=0; j<tubelength[i]; j++) {

      phi = dphi * (float)j;
      cphi = cos(phi);
      sphi = sin(phi);
      tubes[i][j][0] = cthe * (radcent + radhoriz * cphi);
      tubes[i][j][1] = sthe * (radcent + radhoriz * cphi);
      tubes[i][j][2] =                   radvert  * sphi;
      tubevalue[i][j] = 1.0f;

      printf("%f  %f  %f  %f\n", tubes[i][j][0],
                                 tubes[i][j][1],
                                 tubes[i][j][2],
                                 tubevalue[i][j]);
    }
  }

  return 0;
}

