#!/bin/sh
#
##########################################################
##########################################################
##########################################################
proc selectHV { } {
toplevel .hv ;

}

##########################################################
##########################################################
##########################################################

proc load_lut {} {
    set types { {{LUT Files} {.lut}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadluts $filename" }
}
proc save_lut {} {     set types { {{LUT Files} {.lut}} }
    set filename [tk_getSaveFile -filetypes $types]
    if { $filename != "" } { puts "saveluts $filename" }
}

set alpha 0.0

proc editColorMap { } {
toplevel .cmap ;

puts "cmap_edit 1"

label  .cmap.lab_rgb -text "Color"
label  .cmap.lab_dsh -text "-"
label  .cmap.lab_alp -text "Alpha"
label  .cmap.lab_sel -text "Select Knot  "
label  .cmap.lab_mov -text "  Move Knot  "
label  .cmap.lab_set -text "  Set Knot Value  "

button .cmap.cknotmm -text "<" -command { puts "cmap_cknotmm"; }
button .cmap.cknotpp -text ">" -command { puts "cmap_cknotpp"; }
button .cmap.aknotmm -text "<" -command { puts "cmap_aknotmm"; }
button .cmap.aknotpp -text ">" -command { puts "cmap_aknotpp"; }
button .cmap.ckntadd -text "Add" -command { puts "cmap_cknotadd"; }
button .cmap.ckntdel -text "Del" -command { puts "cmap_cknotdel"; }
button .cmap.akntadd -text "Add" -command { puts "cmap_aknotadd"; }
button .cmap.akntdel -text "Del" -command { puts "cmap_aknotdel"; }

button .cmap.amovm10 -text "-10" -command { puts "cmap_move_a  -10" }
button .cmap.amovm01 -text "-1"  -command { puts "cmap_move_a  -1"  }
button .cmap.amovp01 -text "+1"  -command { puts "cmap_move_a  +1"  }
button .cmap.amovp10 -text "+10" -command { puts "cmap_move_a  +10" }
button .cmap.cmovm10 -text "-10" -command { puts "cmap_move_c  -10" }
button .cmap.cmovm01 -text "-1"  -command { puts "cmap_move_c  -1"  }
button .cmap.cmovp01 -text "+1"  -command { puts "cmap_move_c  +1"  }
button .cmap.cmovp10 -text "+10" -command { puts "cmap_move_c  +10" }
button .cmap.csetblk -text "Black " -command { puts "cmap_set_c  0.0 0.0 0.0" }
button .cmap.csetgre -text "Gray  " -command { puts "cmap_set_c  0.5 0.5 0.5" }
button .cmap.csetwht -text "White " -command { puts "cmap_set_c  1.0 1.0 1.0" }
button .cmap.csetred -text "Red   " -command { puts "cmap_set_c  1.0 0.0 0.0" }
button .cmap.csetgrn -text "Green " -command { puts "cmap_set_c  0.0 1.0 0.0" }
button .cmap.csetblu -text "Blue  " -command { puts "cmap_set_c  0.0 0.0 1.0" }
button .cmap.csetylw -text "Yellow" -command { puts "cmap_set_c  1.0 1.0 0.0" }
button .cmap.csetaqu -text "Aqua  " -command { puts "cmap_set_c  0.0 1.0 1.0" }
button .cmap.csetprl -text "Purple" -command { puts "cmap_set_c  1.0 0.0 1.0" }
button .cmap.csetmor -text "More ..." -command { puts "cmap_set_cc [tk_chooseColor]" }

button .cmap.loadlut  -text "Load LUT"  -command "load_lut"
button .cmap.savelut  -text "Save LUT"  -command "save_lut"
button .cmap.aset -text "Set alpha" -command { puts "cmap_set_a  [expr $alpha/100.0]" }
scale  .cmap.scla -orient h -digit 1 -from 0 -to 100 \
    -variable alpha -tickinterval 50



button .cmap.close  -text "Close"  -command { puts "cmap_edit 0";  destroy .cmap }

grid .cmap.lab_sel -in .cmap -row 1 -column 2 -columnspan 2
grid .cmap.lab_mov -in .cmap -row 1 -column 4 -columnspan 4
grid .cmap.lab_set -in .cmap -row 1 -column 8 -columnspan 3

grid .cmap.lab_rgb -in .cmap -row 3 -column 1
grid .cmap.cknotmm -in .cmap -row 3 -column 2
grid .cmap.cknotpp -in .cmap -row 3 -column 3
grid .cmap.cmovm10 -in .cmap -row 3 -column 4
grid .cmap.cmovm01 -in .cmap -row 3 -column 5
grid .cmap.cmovp01 -in .cmap -row 3 -column 6
grid .cmap.cmovp10 -in .cmap -row 3 -column 7
grid .cmap.ckntadd -in .cmap -row 4 -column 2
grid .cmap.ckntdel -in .cmap -row 4 -column 3

grid .cmap.csetblk -in .cmap -row 2 -column 8
grid .cmap.csetgre -in .cmap -row 2 -column 9
grid .cmap.csetwht -in .cmap -row 2 -column 10
grid .cmap.csetred -in .cmap -row 3 -column 8
grid .cmap.csetgrn -in .cmap -row 3 -column 9
grid .cmap.csetblu -in .cmap -row 3 -column 10
grid .cmap.csetmor -in .cmap -row 3 -column 11
grid .cmap.csetylw -in .cmap -row 4 -column 8
grid .cmap.csetaqu -in .cmap -row 4 -column 9
grid .cmap.csetprl -in .cmap -row 4 -column 10

grid .cmap.lab_dsh -in .cmap -row 5 -column 1

grid .cmap.lab_alp -in .cmap -row 6 -column 1
grid .cmap.aknotmm -in .cmap -row 6 -column 2
grid .cmap.aknotpp -in .cmap -row 6 -column 3
grid .cmap.amovm10 -in .cmap -row 6 -column 4
grid .cmap.amovm01 -in .cmap -row 6 -column 5
grid .cmap.amovp01 -in .cmap -row 6 -column 6
grid .cmap.amovp10 -in .cmap -row 6 -column 7
grid .cmap.scla    -in .cmap -row 6 -column 8 -columnspan 3 -rowspan 2
grid .cmap.aset    -in .cmap -row 6 -column 11
grid .cmap.akntadd -in .cmap -row 7 -column 2
grid .cmap.akntdel -in .cmap -row 7 -column 3

grid .cmap.lab_dsh -in .cmap -row 9 -column 1
grid .cmap.loadlut -in .cmap  -row 10  -column 5 -columnspan 2
grid .cmap.savelut -in .cmap  -row 10  -column 8 -columnspan 2
grid .cmap.close   -in .cmap  -row 10  -column 11
}

##########################################################
##########################################################
##########################################################

set fldfile "   -- Need To Select --"
set sclfile "Magnitude"
set fldthresh "0.0"
set fldsampdirs "EYE"
set fldsampn1 1
set fldsampn2 1
set fldsampn3 1
set fldsamprad "0.05"
set fldsampmax "1000"
set fldsamptim "10"
set fldsampsiz "50"
set fldmoveprcnt "5"
set fldsampsetcent 1
set fldclrlo "#008000"
set fldclrhi "#FFFFFF"

proc fld_but_fldselect {} {
  .fld.file.ent delete 0 end
  .fld.file.ent insert 0 [tk_getOpenFile]
}

proc fld_but_sclselect {} {
  .fld.file.sent delete 0 end
  .fld.file.sent insert 0 [tk_getOpenFile]
}

proc fld_color_but_lo  {} {
  global fldclrlo fldclrhi
  set clrtmp [tk_chooseColor -initialcolor $fldclrlo -title "Low Value Color"]
  if { $clrtmp != "" } {
    set fldclrlo $clrtmp
    .fld.color.cnv_lo config -background $fldclrlo
    puts "fldlohiclr $fldclrlo $fldclrhi"
    puts "dorender"
  }
}

proc fld_color_but_hi  {} {
  global fldclrlo fldclrhi
  set clrtmp [tk_chooseColor -initialcolor $fldclrhi -title "High Value Color"]
  if { $clrtmp != "" } {
    set fldclrhi $clrtmp
    .fld.color.cnv_hi config -background $fldclrhi
    puts "fldlohiclr $fldclrlo $fldclrhi"
    puts "dorender"
  }
}

proc fld_but_generate {} {
  global fldsampdirs fldsampn1 fldsampn2 fldsampn3 fldsampsetcent
  global fldsamprad fldsampmax fldsamptim fldsampsiz fldmoveprcnt
  global fldclrlo fldclrhi
  puts "flddim     $fldsampn1 $fldsampn2 $fldsampn3"
  puts "flddir     $fldsampdirs"
  puts "fldrad     $fldsamprad"
  puts "fldmax     $fldsampmax"
  puts "fldtim     $fldsamptim"
  puts "fldprcnt   $fldsampsiz"
  puts "fldsetcent $fldsampsetcent"
  puts "fldfile    [.fld.file.ent get]"
  puts "fldthresh  [.fld.file.tent get]"
  puts "fldcolor   [.fld.file.sent get]"
  puts "fldlohiclr $fldclrlo $fldclrhi"
  puts "fldgen"
}

proc fld_but_tuberad { } {
  global fldsamprad
  puts "fldrad     $fldsamprad"
  puts "dorender"
}


proc makeFieldLines { } {
toplevel .fld ;


##########################################################
##########################################################
frame .fld.file

label  .fld.file.lab  -text "X-Field OR File"
button .fld.file.but  -text "Select ..." -command "fld_but_fldselect"
entry  .fld.file.ent  -textvariable fldfile -width 64
label  .fld.file.slab -text "Path to Scalar File"
button .fld.file.sbut -text "Select ..." -command "fld_but_sclselect"
entry  .fld.file.sent -textvariable sclfile -width 64

label  .fld.file.ilab -text "Or, Tube Color Based on:"
button .fld.file.magb -text "Magnitude" -command "set sclfile Magnitude"
button .fld.file.dirb -text "Direction" -command "set sclfile Direction"

label  .fld.file.tlab -text "Mag. Threshold:"
entry  .fld.file.tent  -textvariable fldthresh -width 8

grid .fld.file.lab  -in .fld.file -row 1 -column 1
grid .fld.file.but  -in .fld.file -row 1 -column 2
grid .fld.file.ent  -in .fld.file -row 1 -column 3 -columnspan 8
grid .fld.file.slab -in .fld.file -row 2 -column 1
grid .fld.file.sbut -in .fld.file -row 2 -column 2
grid .fld.file.sent -in .fld.file -row 2 -column 3 -columnspan 8 

grid .fld.file.ilab -in .fld.file -row 3 -column 1 -sticky e -columnspan 2
grid .fld.file.magb -in .fld.file -row 3 -column 3 -sticky w
grid .fld.file.dirb -in .fld.file -row 3 -column 4 -sticky w

grid .fld.file.tlab -in .fld.file -row 3 -column 5 -sticky e
grid .fld.file.tent -in .fld.file -row 3 -column 6 -sticky w


##########################################################
##########################################################
frame .fld.samp


# Directions and lengths
label  .fld.samp.labdirs -text "Directions (1,2,3)"
radiobutton .fld.samp.rdbdirs_eye -text "(Horizontal,Up,Eye)" \
                                  -variable fldsampdirs -value "EYE"
radiobutton .fld.samp.rdbdirs_xyz -text "(X,Y,Z)" \
                                  -variable fldsampdirs -value "XYZ"
radiobutton .fld.samp.rdbdirs_pre -text "Previous Directions" \
                                  -variable fldsampdirs -value "PRE"
.fld.samp.rdbdirs_eye select
label  .fld.samp.labmax -text "Max Length"
label  .fld.samp.labtim -text "Time"
label  .fld.samp.labsiz -text "Fill (% of View)"
entry  .fld.samp.entmax -textvariable fldsampmax -width 5
entry  .fld.samp.enttim -textvariable fldsamptim -width 5
entry  .fld.samp.entsiz -textvariable fldsampsiz -width 5

grid .fld.samp.labdirs     -in .fld.samp -row 1 -column 1 -sticky w -columnspan 2
grid .fld.samp.rdbdirs_eye -in .fld.samp -row 2 -column 1 -sticky w -columnspan 2
grid .fld.samp.rdbdirs_xyz -in .fld.samp -row 3 -column 1 -sticky w -columnspan 2
grid .fld.samp.rdbdirs_pre -in .fld.samp -row 4 -column 1 -sticky w -columnspan 2
grid .fld.samp.labmax      -in .fld.samp -row 5 -column 1 -sticky e
grid .fld.samp.labtim      -in .fld.samp -row 6 -column 1 -sticky e
grid .fld.samp.labsiz      -in .fld.samp -row 7 -column 1 -sticky e
grid .fld.samp.entmax      -in .fld.samp -row 5 -column 2 -sticky w
grid .fld.samp.enttim      -in .fld.samp -row 6 -column 2 -sticky w
grid .fld.samp.entsiz      -in .fld.samp -row 7 -column 2 -sticky w

button .fld.samp.butrad -text "Set Tube Radius" -command "fld_but_tuberad"
entry  .fld.samp.entrad -textvariable fldsamprad -width 5
grid .fld.samp.butrad      -in .fld.samp -row 8 -column 1 -sticky e
grid .fld.samp.entrad      -in .fld.samp -row 8 -column 2 -sticky w

# Insert a space
label .fld.samp.labspace -text "      "
grid  .fld.samp.labspace -in .fld.samp -row 1 -column 3

# Dimensions
label  .fld.samp.labdimA -text "Number of Starting Points"
label  .fld.samp.labdimB -text "in Each Direction"
label  .fld.samp.labn1 -text "N1"
label  .fld.samp.labn2 -text "N2"
label  .fld.samp.labn3 -text "N3"
entry  .fld.samp.entn1 -textvariable fldsampn1 -width 4
entry  .fld.samp.entn2 -textvariable fldsampn2 -width 4
entry  .fld.samp.entn3 -textvariable fldsampn3 -width 4
button .fld.samp.butgo -text "Generate Field Lines" -command "fld_but_generate"
checkbutton .fld.samp.chksetcent -text "Reset center of sample" \
                                 -variable fldsampsetcent

grid .fld.samp.labdimA -in .fld.samp -row 1 -column 4 -columnspan 2
grid .fld.samp.labdimB -in .fld.samp -row 2 -column 4 -columnspan 2
grid .fld.samp.labn1   -in .fld.samp -row 3 -column 4 -sticky e
grid .fld.samp.labn2   -in .fld.samp -row 4 -column 4 -sticky e
grid .fld.samp.labn3   -in .fld.samp -row 5 -column 4 -sticky e
grid .fld.samp.entn1   -in .fld.samp -row 3 -column 5 -sticky w
grid .fld.samp.entn2   -in .fld.samp -row 4 -column 5 -sticky w
grid .fld.samp.entn3   -in .fld.samp -row 5 -column 5 -sticky w
grid .fld.samp.butgo   -in .fld.samp -row 7 -column 4 -columnspan 2 -sticky w
grid .fld.samp.chksetcent   -in .fld.samp -row 8 -column 4 -columnspan 2 -sticky w

##########################################################
##########################################################
frame .fld.move

proc fld_move_but_1p  {} { puts "fldshift   [.fld.move.ent_prcnt get] 0.0 0.0" }
proc fld_move_but_1m  {} { puts "fldshift  -[.fld.move.ent_prcnt get] 0.0 0.0" }
proc fld_move_but_2p  {} { puts "fldshift  0.0  [.fld.move.ent_prcnt get] 0.0" }
proc fld_move_but_2m  {} { puts "fldshift  0.0 -[.fld.move.ent_prcnt get] 0.0" }
proc fld_move_but_3p  {} { puts "fldshift  0.0 0.0  [.fld.move.ent_prcnt get]" }
proc fld_move_but_3m  {} { puts "fldshift  0.0 0.0 -[.fld.move.ent_prcnt get]" }

label  .fld.move.lab_prcnt -text "     Move Staring Points by (% of view)"
entry  .fld.move.ent_prcnt -textvariable fldmoveprcnt -width 5
button .fld.move.but_1p -text "1 ++" -command "fld_move_but_1p"
button .fld.move.but_1m -text "1 --" -command "fld_move_but_1m"
button .fld.move.but_2p -text "2 ++" -command "fld_move_but_2p"
button .fld.move.but_2m -text "2 --" -command "fld_move_but_2m"
button .fld.move.but_3p -text "3 ++" -command "fld_move_but_3p"
button .fld.move.but_3m -text "3 --" -command "fld_move_but_3m"

grid .fld.move.lab_prcnt -in .fld.move -row 1 -column 1 -columnspan 2
grid .fld.move.ent_prcnt -in .fld.move -row 1 -column 3
grid .fld.move.but_1p -in .fld.move  -row 2 -column 1 -sticky e
grid .fld.move.but_1m -in .fld.move  -row 2 -column 2 -sticky w
grid .fld.move.but_2p -in .fld.move  -row 3 -column 1 -sticky e
grid .fld.move.but_2m -in .fld.move  -row 3 -column 2 -sticky w
grid .fld.move.but_3p -in .fld.move  -row 4 -column 1 -sticky e
grid .fld.move.but_3m -in .fld.move  -row 4 -column 2 -sticky w


##########################################################
##########################################################
frame .fld.color

global fldclrlo fldclrhi

label  .fld.color.lab_lo -text "     Low Value"
label  .fld.color.lab_hi -text "     High Value"
canvas .fld.color.cnv_lo -width 2c -height 0.8c -background $fldclrlo
canvas .fld.color.cnv_hi -width 2c -height 0.8c -background $fldclrhi
button .fld.color.but_lo -text "Change ..." -command "fld_color_but_lo"
button .fld.color.but_hi -text "Change ..." -command "fld_color_but_hi"

grid .fld.color.lab_lo -in .fld.color -row 1 -column 1
grid .fld.color.lab_hi -in .fld.color -row 2 -column 1
grid .fld.color.cnv_lo -in .fld.color -row 1 -column 2
grid .fld.color.cnv_hi -in .fld.color -row 2 -column 2
grid .fld.color.but_lo -in .fld.color -row 1 -column 3
grid .fld.color.but_hi -in .fld.color -row 2 -column 3


##########################################################
##########################################################

grid .fld.file  -in .fld -pady 10 -row 1 -column 1 -columnspan 2
grid .fld.samp  -in .fld -pady 10 -row 2 -column 1 -rowspan 2
grid .fld.move  -in .fld -pady 10 -row 2 -column 2 -sticky n
grid .fld.color -in .fld -pady 10 -row 3 -column 2 -sticky s

}

##########################################################
##########################################################
##########################################################

##########################################################
##########################################################
frame .popups

button .popups_fld -text "Field Lines ..." -command { makeFieldLines }
button .popups_map -text "Edit Color Map ..." -command { editColorMap }
button .popups_clr -text "Color Map On/Off" -command { puts "cmap_show" }

grid .popups_fld -in .popups  -row 1  -column 1
grid .popups_map -in .popups  -row 1  -column 2
grid .popups_clr -in .popups  -row 1  -column 3


##########################################################
##########################################################
frame .hvs

set hvfilter *.hv

proc sesame {} {
  puts "loadhv [.hvs.hv_files get [.hvs.hv_files curselection]]"
}
proc gethvlist {} {
    global hvfilter
    set err [catch {set files [split [glob $hvfilter]]}]
    .hvs.hv_files delete 0 end
    if { $err == 0 } {
      foreach file $files {
        .hvs.hv_files insert end $file
      }
    }
}
#
label     .hvs.lab_filter -text "HV File Filter:"
entry     .hvs.ent_filter -textvariable hvfilter
button    .hvs.but_gethvs -text "Apply Filter" -command "gethvlist"
scrollbar .hvs.myscroll -command ".hvs.hv_files yview"
listbox   .hvs.hv_files -selectmode single -height 20 -yscrollcommand ".hvs.myscroll set"
bind      .hvs.hv_files <Double-ButtonPress-1> { sesame }
#
grid .hvs.lab_filter -in .hvs -row 1 -column 1 -columnspan 2
grid .hvs.ent_filter -in .hvs -row 2 -column 1 -columnspan 2
grid .hvs.but_gethvs -in .hvs -row 3 -column 1 -columnspan 2
grid .hvs.hv_files   -in .hvs -row 4 -column 1
grid .hvs.myscroll   -in .hvs -row 4 -column 2 -sticky ns


##########################################################
##########################################################
frame .fileio

proc load_hv {} {
    set types { {{HV Files} {.hv}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadhv $filename" }
}
proc load_vec {} {
    set types { {{VEC Files} {.vec}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadvec $filename" }
}
proc load_key {} {
    set types { {{KEY Files} {.key}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadkey $filename" }
}
proc save_key {} {
    set types { {{KEY Files} {.key}} }
    set filename [tk_getSaveFile -filetypes $types]
    if { $filename != "" } { puts "savekey $filename" }
}
proc load_view {} {
    set types { {{VIEW Files} {.view}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadview $filename" }
}
proc save_view {} {
    set types { {{VIEW Files} {.view}} }
    set filename [tk_getSaveFile -filetypes $types]
    if { $filename != "" } { puts "saveview $filename" }
}

proc save_image {} {
    set types { {{Image Files} {.jpg}} }
    set filename [tk_getSaveFile -filetypes $types]
    if { $filename != "" } { puts "saveimage $filename" }
}
proc save_image {} {
    set types { {{Image Files} {.jpg}} }
    set filename [tk_getSaveFile -filetypes $types]
    if { $filename != "" } { puts "saveimage $filename" }
}

proc save_movie {} {
    global moviename
    global .but_save_movie
    if { $moviename == "" } {
      set types { {{Image Files} {.movie}} }
      set moviename [tk_getSaveFile -filetypes $types]
      if { $moviename != "" } { puts "movie_start $moviename" }
      .but_save_movie configure -text "End Movie"
    } else {
      set moviename ""
      puts "movie_end"
      .but_save_movie configure -text "Start Movie"
    }
}

proc button_rot90hp   {} { puts "trackball90     [.ent1 get]  0.0 0.0" }
proc button_rot90hm   {} { puts "trackball90    -[.ent1 get]  0.0 0.0" }
proc button_rot90vp   {} { puts "trackball90     0.0 -[.ent1 get] 0.0" }
proc button_rot90vm   {} { puts "trackball90     0.0  [.ent1 get] 0.0" }
set myentry 10
set moviename ""

button .but_load_hv    -text "Load HV"     -command "load_hv"    -width 8
button .but_load_vec   -text "Load Vec"    -command "load_vec"   -width 8
button .but_load_key   -text "Load Key"    -command "load_key"   -width 8
button .but_save_key   -text "Save Key"    -command "save_key"   -width 8
button .but_load_view  -text "Load View"   -command "load_view"  -width 8
button .but_save_view  -text "Save View"   -command "save_view"  -width 8
button .but_save_image -text "Save Image"  -command "save_image" -width 8
button .but_save_movie -text "Start Movie" -command "save_movie" -width 8

label  .spacerot   -text " " -width 4
entry  .ent1     -textvariable myentry -width 5
button .but_90hp -text "<<" -command "button_rot90hp"
button .but_90hm -text ">>" -command "button_rot90hm"
button .but_90vp -text "^^" -command "button_rot90vp"
button .but_90vm -text "vv" -command "button_rot90vm"

grid .but_load_hv    -in .fileio  -row 1  -column 1
grid .but_load_vec   -in .fileio  -row 2  -column 1
grid .but_load_view  -in .fileio  -row 1  -column 2
grid .but_save_view  -in .fileio  -row 2  -column 2
grid .but_load_key   -in .fileio  -row 1  -column 3
grid .but_save_key   -in .fileio  -row 2  -column 3
grid .but_save_image -in .fileio  -row 3  -column 2
grid .but_save_movie -in .fileio  -row 3  -column 3

grid .spacerot   -in .fileio  -row 2  -column 4
grid .ent1       -in .fileio  -row 2  -column 6
grid .but_90hp   -in .fileio  -row 2  -column 5
grid .but_90hm   -in .fileio  -row 2  -column 7
grid .but_90vp   -in .fileio  -row 1  -column 6
grid .but_90vm   -in .fileio  -row 3  -column 6

##########################################################
##########################################################
frame .view

##########################################################
frame .preecup

proc button_xhyv  {} { puts "ecandup     0 0 1  0 1 0" }
proc button_yhzv  {} { puts "ecandup     1 0 0  0 0 1" }
proc button_zhxv  {} { puts "ecandup     0 1 0  1 0 0" }

proc button_ecup {a b c d e f} { puts "ecandup     $a $b $c $d $e $f" }
proc button_center {a b c }   { puts "center      $a $b $c" }

label .lab_preecup -text "(horizontal,vertical)"
button .but_xhyv -text "(+x,+y)" -command "button_xhyv"
button .but_yhzv -text "(+y,+z)" -command "button_yhzv"
button .but_zhxv -text "(+z,+x)" -command "button_zhxv"
button .but_yhxv -text "(+y,+x)" -command "button_ecup   0  0 -1   1  0  0"
button .but_zhyv -text "(+z,+y)" -command "button_ecup  -1  0  0   0  1  0"
button .but_xhzv -text "(+x,+z)" -command "button_ecup   0 -1  0   0  0  1"
button .but_center -text "Reset (0,0,0)" -command "button_center   0 0 0"

grid .lab_preecup  -in .preecup  -row 1 -column 1 -columnspan 2
grid .but_xhyv     -in .preecup  -row 2 -column 1
grid .but_yhzv     -in .preecup  -row 3 -column 1
grid .but_zhxv     -in .preecup  -row 4 -column 1
grid .but_yhxv     -in .preecup  -row 2 -column 2
grid .but_zhyv     -in .preecup  -row 3 -column 2
grid .but_xhzv     -in .preecup  -row 4 -column 2
grid .but_center   -in .preecup  -row 5 -column 1 -columnspan 2

##########################################################
frame .trackball

proc button_rotph {} { puts "trackball   -[.ent1 get] 0.0 0.0" }
proc button_rotpv {} { puts "trackball   0.0 -[.ent1 get] 0.0" }
proc button_rotmh {} { puts "trackball   [.ent1 get] 0.0 0.0" }
proc button_rotmv {} { puts "trackball   0.0 [.ent1 get] 0.0" }

label .lab_tball -text "Rotate"
button .but_rotph -text ">" -command "button_rotph"
button .but_rotmh -text "<" -command "button_rotmh"
button .but_rotpv -text "^" -command "button_rotpv"
button .but_rotmv -text "v" -command "button_rotmv"

grid .lab_tball -in .trackball  -row 2 -column 2
grid .but_rotmh -in .trackball  -row 2 -column 1
grid .but_rotph -in .trackball  -row 2 -column 3
grid .but_rotpv -in .trackball  -row 1 -column 2
grid .but_rotmv -in .trackball  -row 3 -column 2

##########################################################
frame .zoom
proc button_zoomout {} { puts "trackball   0.0 0.0 [.ent1 get]" }
proc button_zoomin  {} { puts "trackball   0.0 0.0 -[.ent1 get]" }

button .but_zoomin  -text "Zoom In"  -command "button_zoomin"  -width 8
button .but_zoomout -text "Zoom OUT" -command "button_zoomout" -width 8

grid .but_zoomin  -in .zoom  -row 1 -column 1
grid .but_zoomout -in .zoom  -row 2 -column 1

##########################################################
frame .shift
proc button_shiftph  {} { puts "shift    -[.ent1 get] 0.0 0.0" }
proc button_shiftpv  {} { puts "shift    0.0 -[.ent1 get] 0.0" }
proc button_shiftmh  {} { puts "shift    [.ent1 get] 0.0 0.0" }
proc button_shiftmv  {} { puts "shift    0.0 [.ent1 get] 0.0" }

label .lab_shift -text "Shift"
button .but_shiftph -text ">" -command "button_shiftph"
button .but_shiftmh -text "<" -command "button_shiftmh"
button .but_shiftpv -text "^" -command "button_shiftpv"
button .but_shiftmv -text "v" -command "button_shiftmv"

grid .lab_shift   -in .shift  -row 2 -column 2
grid .but_shiftmh -in .shift  -row 2 -column 1
grid .but_shiftph -in .shift  -row 2 -column 3
grid .but_shiftpv -in .shift  -row 1 -column 2
grid .but_shiftmv -in .shift  -row 3 -column 2

##########################################################
frame .fly
proc button_flyfor  {} { puts "shift    0.0 0.0 -[.ent1 get]" }
proc button_flybac  {} { puts "shift    0.0 0.0 [.ent1 get]" }

button .but_flyfor -text "Forward" -command "button_flyfor" -width 8
button .but_flybac -text " Back  " -command "button_flybac" -width 8

grid .but_flyfor -in .fly  -row 1 -column 1
grid .but_flybac -in .fly  -row 2 -column 1

##########################################################
grid .preecup   -in .view  -row 1 -column 1  -padx 10 -rowspan 2
grid .trackball -in .view  -row 1 -column 2  -padx 10
grid .zoom      -in .view  -row 2 -column 2  -padx 10
grid .shift     -in .view  -row 1 -column 3  -padx 10
grid .fly       -in .view  -row 2 -column 3  -padx 10

##########################################################
##########################################################
# ame .clip  -relief raised -borderwidth 2
frame .clip

set myclip 0.05
proc button_clip_pm {a} { puts "clipcpm  $a  $a" }
proc button_myclip {} { button_clip_pm [.entclip get] }

# proc button_clip_pm0p001 {} { puts "clipcpm  0.001 0.001" }
# proc button_clip_pm0p010 {} { puts "clipcpm  0.01  0.01 " }
# proc button_clip_pm0p100 {} { puts "clipcpm  0.1   0.1  " }
# proc button_clip_pm0001p {} { puts "clipcpm  1.0   1.0  " }
# proc button_clip_pm0010p {} { puts "clipcpm  10    10   " }
# proc button_clip_pm0100p {} { puts "clipcpm  100   100  " }
# proc button_clip_pm1000p {} { puts "clipcpm  1000  1000 " }

label .lab_clip -text "Distance of Near and Far clipping planes from center point"
button .but_clip_pm0p001 -text "0.001" -command "button_clip_pm 0.001"
button .but_clip_pm0p010 -text "0.01 " -command "button_clip_pm 0.01"
button .but_clip_pm0p100 -text "0.1  " -command "button_clip_pm 0.1"
button .but_clip_pm0001p -text "1    " -command "button_clip_pm 1"
button .but_clip_pm0010p -text "10   " -command "button_clip_pm 10"
button .but_clip_pm0100p -text "100  " -command "button_clip_pm 100"
button .but_clip_pm1000p -text "1000 " -command "button_clip_pm 1000"

button .but_clip_auxset -text "Set 3D clip from view" -command "puts clip_aux_set"
button .but_clip_auxoff -text "3D Clip Off" -command "puts clip_aux_off"
button .but_clip_pmedit -text "Clip:" -command "button_myclip"
entry  .entclip  -textvariable myclip -width 8

grid .lab_clip         -in .clip  -row 1 -column 1 -columnspan 7
grid .but_clip_pm0p001 -in .clip  -row 2 -column 1
grid .but_clip_pm0p010 -in .clip  -row 2 -column 2
grid .but_clip_pm0p100 -in .clip  -row 2 -column 3
grid .but_clip_pm0001p -in .clip  -row 2 -column 4
grid .but_clip_pm0010p -in .clip  -row 2 -column 5
grid .but_clip_pm0100p -in .clip  -row 2 -column 6
grid .but_clip_pm1000p -in .clip  -row 2 -column 7

grid .but_clip_auxset -in .clip  -row 3 -column 1 -columnspan 3
grid .but_clip_auxoff -in .clip  -row 3 -column 4 -columnspan 2
grid .but_clip_pmedit -in .clip  -row 3 -column 6
grid .entclip         -in .clip  -row 3 -column 7


##########################################################
##########################################################

grid .hvs    -in . -padx 5 -row 1 -column 1 -rowspan 4
grid .fileio -in . -pady 5 -row 1 -column 2
grid .view   -in . -pady 5 -row 2 -column 2
grid .clip   -in . -pady 5 -row 3 -column 2
grid .popups -in . -pady 5 -row 4 -column 2

gethvlist
