#!/bin/sh
#
##########################################################
##########################################################
frame .globalcontrol

proc load_hv {} {
    set types { {{HV Files} {.hv}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadhv $filename" }
}
proc load_vec {} {
    set types { {{VEC Files} {.vec}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadvec $filename" }
}
proc load_key {} {
    set types { {{KEY Files} {.key}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadkey $filename" }
}
proc save_key {} {
    set types { {{KEY Files} {.key}} }
    set filename [tk_getSaveFile -filetypes $types]
    if { $filename != "" } { puts "savekey $filename" }
}
proc load_view {} {
    set types { {{VIEW Files} {.view}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadview $filename" }
}
proc save_view {} {
    set types { {{VIEW Files} {.view}} }
    set filename [tk_getSaveFile -filetypes $types]
    if { $filename != "" } { puts "saveview $filename" }
}
proc load_lut {} {
    set types { {{LUT Files} {.lut}} }
    set filename [tk_getOpenFile -filetypes $types]
    if { $filename != "" } { puts "loadluts $filename" }
}
proc save_lut {} {
    set types { {{LUT Files} {.lut}} }
    set filename [tk_getSaveFile -filetypes $types]
    if { $filename != "" } { puts "saveluts $filename" }
}

proc button_rot100ph    {} { puts "trackball100   [.ent1 get] 0.0 0.0" }
set myentry 0.1

button .but_load_hv   -text "Load HV"   -command "load_hv"
button .but_load_vec  -text "Load Vec"  -command "load_vec"
button .but_load_key  -text "Load Key"  -command "load_key"
button .but_save_key  -text "Save Key"  -command "save_key"
button .but_load_view -text "Load View" -command "load_view"
button .but_save_view -text "Save View" -command "save_view"
button .but_load_lut  -text "Load LUT"  -command "load_lut"
button .but_save_lut  -text "Save LUT"  -command "save_lut"

button .but_rot100 -text "Rot 100" -command "button_rot100ph"
entry  .ent1  -textvariable myentry

grid .but_load_hv    -in .globalcontrol  -row 1  -column 1
grid .but_load_vec   -in .globalcontrol  -row 2  -column 1
grid .but_load_key   -in .globalcontrol  -row 1  -column 2
grid .but_save_key   -in .globalcontrol  -row 2  -column 2
grid .but_load_view  -in .globalcontrol  -row 1  -column 3
grid .but_save_view  -in .globalcontrol  -row 2  -column 3
grid .but_load_lut   -in .globalcontrol  -row 1  -column 4
grid .but_save_lut   -in .globalcontrol  -row 2  -column 4
grid .ent1           -in .globalcontrol  -row 1  -column 5
grid .but_rot100     -in .globalcontrol  -row 2  -column 5

##########################################################
##########################################################
frame .view

##########################################################
frame .trackball -relief solid

proc button_rotph       {} { puts "trackball   -[.ent1 get] 0.0 0.0" }
proc button_rotpv       {} { puts "trackball   0.0 -[.ent1 get] 0.0" }
proc button_rotmh       {} { puts "trackball   [.ent1 get] 0.0 0.0" }
proc button_rotmv       {} { puts "trackball   0.0 [.ent1 get] 0.0" }

label .lab_tball -text "Rotate"
button .but_rotph -text ">" -command "button_rotph"
button .but_rotmh -text "<" -command "button_rotmh"
button .but_rotpv -text "^" -command "button_rotpv"
button .but_rotmv -text "v" -command "button_rotmv"

grid .lab_tball -in .trackball  -row 2 -column 2
grid .but_rotmh -in .trackball  -row 2 -column 1
grid .but_rotph -in .trackball  -row 2 -column 3
grid .but_rotpv -in .trackball  -row 1 -column 2
grid .but_rotmv -in .trackball  -row 3 -column 2

##########################################################
frame .zoom
proc button_zoomout {} { puts "trackball   0.0 0.0 [.ent1 get]" }
proc button_zoomin  {} { puts "trackball   0.0 0.0 -[.ent1 get]" }

button .but_zoomin  -text "Zoom In"  -command "button_zoomin"
button .but_zoomout -text "Zoom OUT" -command "button_zoomout"

grid .but_zoomin  -in .zoom  -row 1 -column 1
grid .but_zoomout -in .zoom  -row 1 -column 2

##########################################################
frame .shift -relief ridge
proc button_shiftph  {} { puts "shift    -[.ent1 get] 0.0 0.0" }
proc button_shiftpv  {} { puts "shift    0.0 -[.ent1 get] 0.0" }
proc button_shiftmh  {} { puts "shift    [.ent1 get] 0.0 0.0" }
proc button_shiftmv  {} { puts "shift    0.0 [.ent1 get] 0.0" }

label .lab_shift -text "Shift"
button .but_shiftph -text ">" -command "button_shiftph"
button .but_shiftmh -text "<" -command "button_shiftmh"
button .but_shiftpv -text "^" -command "button_shiftpv"
button .but_shiftmv -text "v" -command "button_shiftmv"

grid .lab_shift   -in .shift  -row 2 -column 2
grid .but_shiftmh -in .shift  -row 2 -column 1
grid .but_shiftph -in .shift  -row 2 -column 3
grid .but_shiftpv -in .shift  -row 1 -column 2
grid .but_shiftmv -in .shift  -row 3 -column 2

##########################################################
frame .fly
proc button_flyfor  {} { puts "shift    0.0 0.0 -[.ent1 get]" }
proc button_flybac  {} { puts "shift    0.0 0.0 [.ent1 get]" }

button .but_flyfor -text "Forward" -command "button_flyfor"
button .but_flybac -text " Back  " -command "button_flybac"

grid .but_flyfor -in .fly  -row 1 -column 1
grid .but_flybac -in .fly  -row 1 -column 2

##########################################################
grid .trackball -in .view  -row 1 -column 1  -padx 10
grid .zoom      -in .view  -row 2 -column 1  -padx 10
grid .shift     -in .view  -row 1 -column 2  -padx 10
grid .fly       -in .view  -row 2 -column 2  -padx 10

##########################################################
##########################################################
frame .clip

proc button_clip_pm {a} { puts "clipcpm  $a  $a" }

# proc button_clip_pm0p001 {} { puts "clipcpm  0.001 0.001" }
# proc button_clip_pm0p010 {} { puts "clipcpm  0.01  0.01 " }
# proc button_clip_pm0p100 {} { puts "clipcpm  0.1   0.1  " }
# proc button_clip_pm0001p {} { puts "clipcpm  1.0   1.0  " }
# proc button_clip_pm0010p {} { puts "clipcpm  10    10   " }
# proc button_clip_pm0100p {} { puts "clipcpm  100   100  " }
# proc button_clip_pm1000p {} { puts "clipcpm  1000  1000 " }

label .lab_clip -text "Distance of Near and Far clipping planes from center point"
button .but_clip_pm0p001 -text "0.001" -command "button_clip_pm 0.001"
button .but_clip_pm0p010 -text "0.01 " -command "button_clip_pm 0.01"
button .but_clip_pm0p100 -text "0.1  " -command "button_clip_pm 0.1"
button .but_clip_pm0001p -text "1    " -command "button_clip_pm 1"
button .but_clip_pm0010p -text "10   " -command "button_clip_pm 10"
button .but_clip_pm0100p -text "100  " -command "button_clip_pm 100"
button .but_clip_pm1000p -text "1000 " -command "button_clip_pm 1000"

# button .but_clip_pm0p001 -text "0.001" -command "button_clip_pm0p001"
# button .but_clip_pm0p010 -text "0.01 " -command "button_clip_pm0p010"
# button .but_clip_pm0p100 -text "0.1  " -command "button_clip_pm0p100"
# button .but_clip_pm0001p -text "1    " -command "button_clip_pm0001p"
# button .but_clip_pm0010p -text "10   " -command "button_clip_pm0010p"
# button .but_clip_pm0100p -text "100  " -command "button_clip_pm0100p"
# button .but_clip_pm1000p -text "1000 " -command "button_clip_pm1000p"

grid .lab_clip         -in .clip  -row 1 -column 1 -columnspan 7
grid .but_clip_pm0p001 -in .clip  -row 2 -column 1
grid .but_clip_pm0p010 -in .clip  -row 2 -column 2
grid .but_clip_pm0p100 -in .clip  -row 2 -column 3
grid .but_clip_pm0001p -in .clip  -row 2 -column 4
grid .but_clip_pm0010p -in .clip  -row 2 -column 5
grid .but_clip_pm0100p -in .clip  -row 2 -column 6
grid .but_clip_pm1000p -in .clip  -row 2 -column 7


##########################################################
##########################################################

grid .globalcontrol -in . -pady 5 -row 1 -column 1
grid .view          -in . -pady 5 -row 2 -column 1
grid .clip          -in . -pady 5 -row 3 -column 1


