#include <string.h>
#include <stdio.h>


/* OpenGL Headers */
#define GL_GLEXT_PROTOTYPES
#include <GL/glx.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
#include <X11/extensions/Xdbe.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>

#include <stdlib.h>
#include <limits.h>
#include <math.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <linux/stat.h>

#define STDIN  0
#define STDOUT 1
#define STDERR 2


/************************************************
 *       Defined constants and macros
 ************************************************/
#define _sleep(n) usleep(n*1000)
#define FIFO_FILE       "RDFIFO"

#define HVR_SUCCESS           0
#define FILE_OPEN_FAILED   4001
#define SHORT_FILE_READ    4002


/************************************************
 *             Globale variables
 ************************************************/
Display *dpyHVR;
XVisualInfo *viHVR;
Colormap cmapHVR;
XSetWindowAttributes swaHVR;
Window winHVR;
GLXContext cxHVR;
XEvent eventHVR;

char cFile[256];
unsigned char ucBuf[3*1280*1280];
int iNx, iNy;

/************************************************
 *       Utility routines & prototypes
 ************************************************/
Bool WaitForNotify(Display *d, XEvent *e, char *arg)
{ return (e->type == MapNotify) && (e->xmap.window == (Window)arg); }

int read_pix_from_file_to_buf();

/************************************************
 *               Main routine
 ************************************************/
int main(int argc, char* argv[])
{
    int attributeListDbl[] = { GLX_DOUBLEBUFFER, GLX_RGBA, None };
    int attributeListSgl[] = { GLX_RGBA, None };
    int iNbuffers;
    int i, iVal, ngot;
    int fd, iexit, icount, iexecret;
    FILE *fp;
    char cnewline[256], key[256];

    // Defaults
    iNx = 512;
    iNy = 512;

    fp = fopen("DEBUG_hvr_tester", "w");
    fprintf(fp, "Start of hvr_tester test\n");
    fclose(fp);

    icount = 0;
    iexit = 0;
    while(iexit == 0  &&  icount < 100) {
      if(fgets(cnewline, 256, stdin) == NULL) {
        iexit = 1;
      } else {

        fp = fopen("DEBUG_hvr_tester", "a");
        fprintf(fp, "IN tester: %s", cnewline);
        fclose(fp);

        ngot = sscanf(cnewline, "%s", key);

        if(strcmp(key, "display") == 0) {
          sscanf(cnewline, "%s%s", key, cFile);
          iVal = read_pix_from_file_to_buf();

          write(STDOUT, &iVal, 4);
          if(iVal == 0) { write(STDOUT, ucBuf, 3*iNx*iNy); }
        }

        if(strcmp(key, "exit") == 0) {
          iexit = 1;
          iVal  = 999;
          write(STDOUT, &iVal, 4);
        }
      }
      icount++;
    }

    fp = fopen("DEBUG_hvr_tester", "a");
    fprintf(fp, "End of hvr_tester test\n");
    fclose(fp);
}

int read_pix_from_file_to_buf()
{
    int fd, ngot, iNbytes;
    FILE *fp;

    fd = open(cFile, O_RDONLY);
    if(fd < 0) { return FILE_OPEN_FAILED; }

    iNbytes = 3*iNx*iNy;
    ngot = read(fd, ucBuf, iNbytes);
    close(fd);
    if(ngot < iNbytes) { return SHORT_FILE_READ; }

    return HVR_SUCCESS;
}


