#include "StdAfx.h"

#ifdef _DEBUG
#undef THIS_FILE
 char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#ifndef linux
#define WINDOWS
#endif

#ifdef WINDOWS
#include <stdio.h>
#include <string.h>
#include <sys/timeb.h>
#include <process.h>
/* OpenGL Headers */
#define GLEW_STATIC
#define GL_GLEXT_PROTOTYPES
#include <gl\glew.h>
#include <gl\glut.h>
/* Cg Headers */
// clude <Cg\cg.h>
// clude <Cg\cgGL.h>
// fine USE_GLUT
#endif

#ifdef linux
/* OpenGL Headers */
#define GL_GLEXT_PROTOTYPES
#include <GL/glew.h>
#include <GL/glx.h>
/* Cg Headers */
//  lude <Cg/cg.h>
//  lude <Cg/cgGL.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
#include <X11/extensions/Xdbe.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
//  ine USE_XGL
#endif

#include <stdlib.h>
#include <limits.h>
#include <math.h>
#include "hvr_work.h"
#include "TimeStamp.h"
#include <errno.h>
#include <signal.h>
#include <linux/stat.h>

Display *dpyHVR;
XVisualInfo *viHVR;
Colormap cmapHVR;
XSetWindowAttributes swaHVR;
Window winHVR;
GLXContext cxHVR;
XEvent eventHVR;

Bool WaitForNotify(Display *d, XEvent *e, char *arg)
{ return (e->type == MapNotify) && (e->xmap.window == (Window)arg); }

unsigned char *ucBuf = NULL;
unsigned char *ucPix;

#define FIFO_FILE       "RDFIFO"

int main(int argc, char* argv[])
{
    int attributeListDbl[] = { GLX_DOUBLEBUFFER, GLX_RGBA, None };
    int attributeListSgl[] = { GLX_RGBA, None };
    int iNx, iNy, iNbuffers;
    int i, iNbytes, iVal, ngot;
    int fd, iexit;
    FILE *fp;
    char readbuf[80], key[256];

    fprintf(stdout, "Start\n");

    /* Create the FIFO if it does not exist */
    // umask(0);
    // mknod("RDFIFO", S_IFIFO|0666, 0);

    // system("run_stk &");

    fprintf(stdout, "after system call\n");

      fp = fopen("RDFIFO", "r");
    iexit = 0;
    while(iexit == 0) {
      fgets(readbuf, 80, fp);
      sscanf(readbuf, "%s", key);

      printf("Received key   : -->%s<--\n", key);
      if(strcmp(key, "goodbye") == 0) { iexit = 1; }
    }
      fclose(fp);


    iNx = 1280;
    iNy = 1024;
    iNbuffers = 1;

   
    fprintf(stdout, "End of GUI test.\n");
    if(iNx > 1) { exit(0); }

    iNbytes = 3*iNx*iNy + 4;
    ucBuf = (unsigned char *)malloc(iNbytes);
    iVal = 255;
    fprintf(stdout, "ucBuf allocated & filled\n");

    dpyHVR = XOpenDisplay(":10.0");
    if(dpyHVR == NULL) {
        fprintf(stdout, "Could not XOpenDisplay()\n");
        exit(0);
    }


    fprintf(stdout, "Display opened\n");

    if(iNbuffers == 1) {
      viHVR = glXChooseVisual(dpyHVR, DefaultScreen(dpyHVR), attributeListSgl);
      if (viHVR == NULL) {
          fprintf(stdout,"could not glXChooseVisual single buffered\n");
          exit(0);
      }
    } else {
      viHVR = glXChooseVisual(dpyHVR, DefaultScreen(dpyHVR), attributeListDbl);
      if (viHVR == NULL) {
          fprintf(stdout,"could not glXChooseVisual double buffered\n");
          exit(0);
      }
    }

    cxHVR = glXCreateContext(dpyHVR, viHVR, 0, GL_TRUE);
    cmapHVR = XCreateColormap(dpyHVR, RootWindow(dpyHVR, viHVR->screen),
                                viHVR->visual, AllocNone);
    swaHVR.colormap = cmapHVR;
    swaHVR.border_pixel = 0;
    swaHVR.event_mask = StructureNotifyMask;
    winHVR  =  XCreateWindow(dpyHVR,  RootWindow(dpyHVR, viHVR->screen),
                             0, 0, iNx, iNy,
                             0, viHVR->depth, InputOutput, viHVR->visual,
                             CWBorderPixel|CWColormap|CWEventMask, &swaHVR);

    fprintf(stdout, "Window Created\n");

    XMapWindow(dpyHVR, winHVR);
    XIfEvent(dpyHVR, &eventHVR, WaitForNotify, (char*)winHVR);
    glXMakeCurrent(dpyHVR, winHVR, cxHVR);

    fprintf(stdout, "Window mapped & made current\n");

    glMatrixMode(GL_TEXTURE);
    glDisable(GL_TEXTURE_3D);
    glDisable(GL_BLEND);

    fd = open("aa.out", O_RDONLY);
    // ngot = lseek(fd, offset, SEEK_SET);
    ngot = read(fd, ucBuf, iNbytes);
    close(fd);

    ucPix = &ucBuf[4];
    glDrawPixels(iNx, iNy, GL_RGB, GL_UNSIGNED_BYTE, ucPix);
    glFlush();
    glFinish();

    fprintf(stdout, "Pixels drawn & flushed\n");

    _sleep(5000);
    
    fprintf(stdout, "Sleep done\n");

   // Close window
   if (dpyHVR != NULL) XCloseDisplay(dpyHVR);
   if (ucBuf != NULL) free(ucBuf);


    fprintf(stdout, "Window closed\n");
}
