#include <string.h>
#include <stdio.h>


/* OpenGL Headers */
#define GL_GLEXT_PROTOTYPES
#include <GL/glx.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
#include <X11/extensions/Xdbe.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>

#include <stdlib.h>
#include <limits.h>
#include <math.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <linux/stat.h>

/************************************************
 *       Defined constants and macros
 ************************************************/
#define _sleep(n) usleep(n*1000)
#define FIFO_FILE       "RDFIFO"

/************************************************
 *             Globale variables
 ************************************************/
Display *dpyHVR;
XVisualInfo *viHVR;
Colormap cmapHVR;
XSetWindowAttributes swaHVR;
Window winHVR;
GLXContext cxHVR;
XEvent eventHVR;

unsigned char *ucBuf = NULL;
unsigned char *ucPix;

/************************************************
 *              Utility routines
 ************************************************/
Bool WaitForNotify(Display *d, XEvent *e, char *arg)
{ return (e->type == MapNotify) && (e->xmap.window == (Window)arg); }

/************************************************
 *               Main routine
 ************************************************/
int main(int argc, char* argv[])
{
    int attributeListDbl[] = { GLX_DOUBLEBUFFER, GLX_RGBA, None };
    int attributeListSgl[] = { GLX_RGBA, None };
    int iNx, iNy, iNbuffers;
    int i, iNbytes, iVal, ngot;
    int fd, iexit, icount, iexecret;
    FILE *fp;
    char cnewline[256], key[256];

    icount = 0;
    iexit = 0;
    while(iexit == 0  &&  icount < 100) {
      ngot = 3;
      if(fgets(cnewline, 256, stdin) != NULL) {
        ngot = sscanf(cnewline, "%s", key);
        printf("(rd:-->%s<--)\n", key);
        fflush(stdout);
      } else {
        iexit = 1;
      }
      icount++;
    }

    iNx = 1280;
    iNy = 1024;
    iNbuffers = 1;

    fprintf(stdout, "(rd:exitting)\n");

    if(iNx > 1) { exit(0); }

    iNbytes = 3*iNx*iNy + 4;
    ucBuf = (unsigned char *)malloc(iNbytes);
    iVal = 255;
    fprintf(stdout, "ucBuf allocated & filled\n");

    dpyHVR = XOpenDisplay(":10.0");
    if(dpyHVR == NULL) {
        fprintf(stdout, "Could not XOpenDisplay()\n");
        exit(0);
    }


    fprintf(stdout, "Display opened\n");

    if(iNbuffers == 1) {
      viHVR = glXChooseVisual(dpyHVR, DefaultScreen(dpyHVR), attributeListSgl);
      if (viHVR == NULL) {
          fprintf(stdout,"could not glXChooseVisual single buffered\n");
          exit(0);
      }
    } else {
      viHVR = glXChooseVisual(dpyHVR, DefaultScreen(dpyHVR), attributeListDbl);
      if (viHVR == NULL) {
          fprintf(stdout,"could not glXChooseVisual double buffered\n");
          exit(0);
      }
    }

    cxHVR = glXCreateContext(dpyHVR, viHVR, 0, GL_TRUE);
    cmapHVR = XCreateColormap(dpyHVR, RootWindow(dpyHVR, viHVR->screen),
                                viHVR->visual, AllocNone);
    swaHVR.colormap = cmapHVR;
    swaHVR.border_pixel = 0;
    swaHVR.event_mask = StructureNotifyMask;
    winHVR  =  XCreateWindow(dpyHVR,  RootWindow(dpyHVR, viHVR->screen),
                             0, 0, iNx, iNy,
                             0, viHVR->depth, InputOutput, viHVR->visual,
                             CWBorderPixel|CWColormap|CWEventMask, &swaHVR);

    fprintf(stdout, "Window Created\n");

    XMapWindow(dpyHVR, winHVR);
    XIfEvent(dpyHVR, &eventHVR, WaitForNotify, (char*)winHVR);
    glXMakeCurrent(dpyHVR, winHVR, cxHVR);

    fprintf(stdout, "Window mapped & made current\n");

    glMatrixMode(GL_TEXTURE);
    glDisable(GL_TEXTURE_3D);
    glDisable(GL_BLEND);

    fd = open("aa.out", O_RDONLY);
    // ngot = lseek(fd, offset, SEEK_SET);
    ngot = read(fd, ucBuf, iNbytes);
    close(fd);

    ucPix = &ucBuf[4];
    glDrawPixels(iNx, iNy, GL_RGB, GL_UNSIGNED_BYTE, ucPix);
    glFlush();
    glFinish();

    fprintf(stdout, "Pixels drawn & flushed\n");

    _sleep(5000);

    fprintf(stdout, "Sleep done\n");

   // Close window
   if (dpyHVR != NULL) XCloseDisplay(dpyHVR);
   if (ucBuf != NULL) free(ucBuf);


    fprintf(stdout, "Window closed\n");
}

