
c---------------------------------------------------------------------72
      subroutine read_header_info(cFile)
      implicit none
      include 'header_info.h'
      character*256 cFile, cline, ckey
      integer i
      data nx/-1/

      cDumpFile = cFile

      ! Parse dump file for available variables and data format & size
      !
      open(unit=17, file=cDumpFile, form='formatted', err=180)
100   continue
      do i = 1, 256
        cline(i:i) = ' '
      enddo
      read (17,991,end=200) cline
991   format(a256)

      if(cline(1:10).eq.'time      ') read (cline,*) ckey,time
      if(cline(1:10).eq.'dtime     ') read (cline,*) ckey,dtime
      if(cline(1:10).eq.'step      ') read (cline,*) ckey,istep
      if(cline(1:10).eq.'ncube     ') read (cline,*) ckey,ncube
      if(cline(1:10).eq.'i2max     ') read (cline,*) ckey,i2max
      if(cline(1:10).eq.'i2off     ') read (cline,*) ckey,i2off
      if(cline(1:10).eq.'ncubesxyz ') read (cline,*) ckey,ncx,ncy,ncz
      if(cline(1:10).eq.'nbrickxyz ') read (cline,*) ckey,nbx,nby,nbz
      if(cline(1:10).eq.'nbpf      ') read (cline,*) ckey,nbricksperfile
      if(cline(1:10).eq.'xlimits   ') read (cline,*) ckey,xbndyL,xbndyR
      if(cline(1:10).eq.'ylimits   ') read (cline,*) ckey,ybndyL,ybndyR
      if(cline(1:10).eq.'zlimits   ') read (cline,*) ckey,zbndyL,zbndyR
      if(cline(1:10).eq.'lobndry   ') then
         read (cline,*) ckey,cLoXbndry,cLoYbndry,cLoZbndry
      endif
      if(cline(1:10).eq.'hibndry   ') then
         read (cline,*) ckey,cHiXbndry,cHiYbndry,cHiZbndry
      endif
      if(cline(1:10).eq.'field3d   ') then
        ndvar = ndvar + 1
        read (cline,*) ckey, cVarSymb(ndvar), cVarName(ndvar),
     1                 cDumpMap(ndvar),dvarmin(ndvar), dvarmax(ndvar)
      endif
      if(cline(1:10).eq.'headsize  ') read (cline,*) ckey,nheadsize


      if(nheadsize .gt. 0) goto 200
      goto 100

180   continue
      write (6,*) "Problem: open failed on dumpfile", cDumpFile
      stop

200   continue
      close(17)

      if(ncube .le. 0) then
        nx = ncx
        ny = ncy
        nz = ncz
      else
        nx = ncx*ncube
        ny = ncy*ncube
        nz = ncz*ncube
      endif

      return
      end

c---------------------------------------------------------------------72
      subroutine get_full_dimensions(nx1,ny1,nz1)
      implicit none
      integer nx1, ny1, nz1
      include 'header_info.h'

      if(nx .lt. 0) then
        write (6,*) 'Problem: header info not set'
        stop
      endif

      nx1 = nx*nbx
      ny1 = ny*nby
      nz1 = nz*nbz

      return
      end

c---------------------------------------------------------------------72
      subroutine xrange2ixos(xlo,xhi,ixoff,ixsize)
      implicit none
      include 'header_info.h'
      integer ixlo,ixhi,ixoff,ixsize
      real    xlo,xhi,xfrac,dx,eps

      eps = 0.01 * (xbndyR-xbndyL) / float(nx*nbx)
      xfrac = (xlo-xbndyL) / (xbndyR-xbndyL)
      ixlo  = max(1, min(nx*nbx, 1+int(float(nx*nbx)*xfrac)))
      xfrac = (xhi-xbndyL-eps) / (xbndyR-xbndyL)
      ixhi  = max(1, min(nx*nbx, 1+int(float(nx*nbx)*xfrac)))

      dx = (xbndyR-xbndyL) / float(nx*nbx)
      xlo = xbndyL + dx * (ixlo - 1)
      xhi = xbndyL + dx * ixhi
      ixoff  = ixlo - 1
      ixsize = 1 + ixhi - ixlo

      return
      end

c---------------------------------------------------------------------72
      subroutine yrange2iyos(ylo,yhi,iyoff,iysize)
      implicit none
      include 'header_info.h'
      integer iylo,iyhi,iyoff,iysize
      real    ylo,yhi,yfrac,dy,eps

      eps = 0.01 * (ybndyR-ybndyL) / float(ny*nby)
      yfrac = (ylo-ybndyL) / (ybndyR-ybndyL)
      iylo  = max(1, min(ny*nby, 1+int(float(ny*nby)*yfrac)))
      yfrac = (yhi-ybndyL-eps) / (ybndyR-ybndyL)
      iyhi  = max(1, min(ny*nby, 1+int(float(ny*nby)*yfrac)))

      dy = (ybndyR-ybndyL) / float(ny*nby)
      ylo = ybndyL + dy * (iylo - 1)
      yhi = ybndyL + dy * iyhi
      iyoff  = iylo - 1
      iysize = 1 + iyhi - iylo

      return
      end

c---------------------------------------------------------------------72
      subroutine zrange2izos(zlo,zhi,izoff,izsize)
      implicit none
      include 'header_info.h'
      integer izlo,izhi,izoff,izsize
      real    zlo,zhi,zfrac,dz, eps

      eps = 0.01 * (zbndyR-zbndyL) / float(nz*nbz)
      zfrac = (zlo-zbndyL) / (zbndyR-zbndyL)
      izlo  = max(1, min(nz*nbz, 1+int(float(nz*nbz)*zfrac)))
      zfrac = (zhi-zbndyL-eps) / (zbndyR-zbndyL)
      izhi  = max(1, min(nz*nbz, 1+int(float(nz*nbz)*zfrac)))

      dz = (zbndyR-zbndyL) / float(nz*nbz)
      zlo = zbndyL + dz * (izlo - 1)
      zhi = zbndyL + dz * izhi
      izoff  = izlo - 1
      izsize = 1 + izhi - izlo

      return
      end

c---------------------------------------------------------------------72
      subroutine xyz2ijk(xx,yy,zz,ix,iy,iz)
      implicit none
      include 'header_info.h'
      integer ix,iy,iz
      real    xx,yy,zz, xfrac,yfrac,zfrac

      xfrac = (xx-xbndyL) / (xbndyR-xbndyL)
      yfrac = (yy-ybndyL) / (ybndyR-ybndyL)
      zfrac = (zz-zbndyL) / (zbndyR-zbndyL)
      ix = max(1, min(nx*nbx, 1+int(float(nx*nbx)*xfrac)))
      iy = max(1, min(ny*nby, 1+int(float(ny*nby)*yfrac)))
      iz = max(1, min(nz*nbz, 1+int(float(nz*nbz)*zfrac)))

      return
      end

c---------------------------------------------------------------------72
      subroutine report_header_info()
      implicit none
      include 'header_info.h'
      integer ilen, i

      if(nx .lt. 0) then
        write (6,*) 'Problem: header info not set'
        return
      endif

      ilen = len(trim(cdumpfile))
      write (6,*) 'Data File: ', cdumpfile(1:ilen)
      write (6,9901) time, dtime, istep
9901  format("Time  = ", f10.5,/,"Dtime = ", f10.5,/,"Step  = ", i5)
      write (6,9902) 'X',xbndyL,xbndyR, nx, nbx
      write (6,9902) 'Y',ybndyL,ybndyR, ny, nby
      write (6,9902) 'Z',zbndyL,zbndyR, nz, nbz
9902  format(a1,":  [", f9.4,",",f8.4,"]   ",
     1       "Brick Size =",i3,   "    # of Bricks =",i3)
      write (6,9903) nx*nbx, ny*nby, nz*nbz
9903  format("Full Dimensions: ", 3i7)

      write (6,*)  "  "
      do i=1,ndvar
        write (6,9904) cVarSymb(i)(1:8), cVarName(i)(1:20),
     1                 cDumpMap(i)(1:10),dvarmin(i), dvarmax(i)
      enddo
9904  format(a8, a20, a10, 1p2e15.6)

      return
      end

c---------------------------------------------------------------------72
      subroutine read_fields(cVars,nvars,nxsub,nysub,nzsub,
     1                       ixoff,iyoff,izoff, flds)
      implicit none
      character*256 cVars, cHost, cDir, cFile
      integer nvars,nxsub,nysub,nzsub,ixoff,iyoff,izoff
      real flds(nvars,nxsub,nysub,nzsub)
      include 'header_info.h'
      integer ncoefs, iilog, i, sw_read
      integer ibrick,ifile,ibrickinfile,ibrickoff,nplanesize
      integer n,nbytes,iv,ix,iy,iz,ixs,iys,izs,ixd,iyd,izd
      integer ibx,ibxoff,ibxmin,ibxmax,ixmin,ixmax
      integer iby,ibyoff,ibymin,ibymax,iymin,iymax
      integer ibz,ibzoff,ibzmin,ibzmax,izmin,izmax
      integer nvar, ivar(MAXDVAR)
      real coefs(10)
      integer*2 slab2i
      real      slab4f
      allocatable  slab2i(:,:,:) ! (ix , iy , iz)
      allocatable  slab4f(:,:,:) ! (ix , iy , iz)

      integer i2mid, ilog(MAXDVAR), ibpv(MAXDVAR),nbricksize,ibytezoff
      integer(kind=8) ivaroff(MAXDVAR), i64size, i64off
      real val, fac,off,fldscl(MAXDVAR),fldmin(MAXDVAR),fldmax(MAXDVAR)


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        Make sure header info is read in                              c
c        Then parse input string "cVars" for fields to be read         c
c        Then allocate scratch arrays                                  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if(nx .lt. 0) then
        write (6,*) 'Problem: header info not set'
        stop
      endif

      call parse_vars(MAXDVAR,ndvar,cVarSymb,cVars,nvar,ivar)
      allocate (slab2i(nx,ny,nzsub))
      allocate (slab4f(nx,ny,nzsub))


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        Derive field scales and offsets, and offsets of data files    c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      i2mid = i2max/2 - i2off
      ivaroff(1) = nheadsize
      do iv = 1, ndvar
        fldmin(iv) = dvarmin(iv)
        fldmax(iv) = dvarmax(iv)
        ilog(iv)   = 0
        if(cDumpMap(iv)(1:10) .eq. "Log_e     ") then
          fldmin(iv) = alog(dvarmin(iv))
          fldmax(iv) = alog(dvarmax(iv))
          ilog(iv)   = 1
        endif
        fldscl(iv) = (fldmax(iv)-fldmin(iv))/float(i2max)

        ! Bytes Per Variable, and offset relative to start of brick, of data in file
        ibpv(iv) = 2
        if(cDumpMap(iv)(1:10) .eq. "real4     ") ibpv(iv) = 4

        i64size = ibpv(iv) * nx * ny * nz
        ivaroff(iv+1) = ivaroff(iv) + i64size
      enddo
      nbricksize = ivaroff(ndvar+1)


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Fill fields array in subrange requeested by                      c
c     sweeping through all bricks that overlap with specified region   c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      ixmin = ixoff + 1            !
      iymin = iyoff + 1            !
      izmin = izoff + 1            ! XYZ ranges in full volume
      ixmax = ixoff + nxsub        !
      iymax = iyoff + nysub        !
      izmax = izoff + nzsub        !

      do ibz=1,nbz
      ibzoff = nz*(ibz-1)
      ibzmin = max( 1+ibzoff, izmin)
      ibzmax = min(nz+ibzoff, izmax)
      if(ibzmin .le. ibzmax) then
         do iby=1,nby
         ibyoff = ny*(iby-1)
         ibymin = max( 1+ibyoff, iymin)
         ibymax = min(ny+ibyoff, iymax)
         if(ibymin .le. ibymax) then
            do ibx=1,nbx
            ibxoff = nx*(ibx-1)
            ibxmin = max( 1+ibxoff, ixmin)
            ibxmax = min(nx+ibxoff, ixmax)
            if(ibxmin .le. ibxmax) then

               ! There is an overlap of spcified range with this brick

               ibrick = ibx-1 + nbx*(iby-1 + nby*(ibz-1))   ! starts at 0
               ifile  = ibrick / nbricksperfile             ! starts at 0
               ibrickinfile = mod(ibrick, nbricksperfile)   ! starts at 0

               call get_HDF(ifile, cDumpFile, cHost, cDir, cFile)
               do i=1,nvar
                 iv = ivar(i)
                 ibrickoff    = nbricksize * ibrickinfile
                 nplanesize   = ibpv(iv) * nx * ny
                 ibytezoff    = nplanesize * mod(ibzmin-1, nz)
                 i64off       = ibrickoff + ivaroff(iv) + ibytezoff
                 nbytes       = (1 + ibzmax - ibzmin) * nplanesize

                 if(ibpv(iv) .eq. 2) then
                   n = sw_read(cHost,cDir,cFile,i64off,nbytes,slab2i)

                   fac = fldscl(iv)
                   off = 0.5 * (fldmin(iv) + fldmax(iv))
                   iilog = ilog(iv)

                   do iz=ibzmin,ibzmax
                   izs = 1 + iz - ibzmin
                   izd = iz - izoff
                   do iy=ibymin,ibymax
                   iys = iy - ibyoff
                   iyd = iy - iyoff
                   do ix=ibxmin,ibxmax
                   ixs = ix - ibxoff
                   ixd = ix - ixoff
                   val = off + fac*float(int(slab2i(ixs,iys,izs))+i2mid)
                   if(iilog .eq. 1) val = exp(val)
                   flds(i,ixd,iyd,izd) = val
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c                   if(ixd.eq.2 .and. iyd.eq.1 .and. izd.eq.1) then
c                     write (6,*) 'val,flds = ', val,flds(1,2,1,1)
c                     write (6,*) 'off,fac  = ', off,fac
c                     write (6,*) 'i2mid    = ', i2mid
c                     write (6,*) 'slab2i   = ',int(slab2i(ixs,iys,izs))
c                     write (6,*) 'i2max,i2off=', i2max, i2off
c                     write (6,*) 'i64off   = ', i64off
c                     write (6,*) 'iv   =',iv
c                     write (6,*) 'iXYZs=',ixs,iys,izs
c                     write (6,*) 'ibzmin,ibzoff=',ibzmin,ibzoff
c                   endif
cccccccccccccccccccccccccccccccccccccccccccccccccccc
                   enddo
                   enddo
                   enddo
c >add
                 else
                   n = sw_read(cHost,cDir,cFile,i64off,nbytes,slab4f)
                   do iz=ibzmin,ibzmax
                   izs = iz - ibzoff
                   izd = iz - izoff
                   do iy=ibymin,ibymax
                   iys = iy - ibyoff
                   iyd = iy - iyoff
                   do ix=ibxmin,ibxmax
                   ixs = ix - ibxoff
                   ixd = ix - ixoff
                   flds(i,ixd,iyd,izd) = slab4f(ixs,iys,izs)
                   enddo
                   enddo
                   enddo
                 endif
               enddo
            endif
            enddo
         endif
         enddo
      endif
      enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      deallocate (slab2i)
      deallocate (slab4f)

      return
      end

C=====================================================================72
      subroutine get_HDF(iFile, cHostDirName, cHost, cDir, cName)
      character*256 cHostDirName, cHost, cDir, cName

      ! Find the index in cHostDirName berween the directory and the file name 
      ! I should be the last character in the string
      islash = 0
      ilast  = 256
      do i=1, 256
        cHost(i:i) = ' '
        cDir(i:i)  = ' '
        cName(i:i) = ' '
        if(cHostDirName(i:i)         .eq. '/') islash = i
        if(cHostDirName(257-i:257-i) .eq. ' ') ilast  = 256-i
      enddo

      iPathLen = islash - 1
      iNameLen = ilast-islash

      ! Default: the file is in the local directory
      cHost(1:9) = 'localdisk'

      if(islash .gt. 0) then
        ! cHostDirName contains path info to the file
        cDir(1:iPathLen)  = cHostDirName(1:iPathLen)
        cName(1:iNameLen) = cHostDirName(islash+1:ilast)
      else
        ! cHostDirName is just the name of the file, assume it is in cwd
        cDir(1:1)  = '.'
        cName      = cHostDirName
      endif

      ! Reformat iFile into last 3 characters of file name
      i1 =     iFile/100
      i2 = mod(iFile/10 , 10)
      i3 = mod(iFile    , 10)
      cName(iNameLen-2:iNameLen-2) = char(ichar('0') + i1)
      cName(iNameLen-1:iNameLen-1) = char(ichar('0') + i2)
      cName(iNameLen  :iNameLen  ) = char(ichar('0') + i3)

      return
      end

C=====================================================================72
      subroutine parse_vars(MAXDVAR,ndvar,cVarSymb,cVars,nvar,ivar)
      character*256 cVarSymb(MAXDVAR)
      character*256 cVars
      integer ndvar, nvar, ivar(MAXDVAR)

      integer i, j, istr, nstr
      character*256  cstr(1000)

      ! Initialize strings
      do j = 1, 1000
        do i = 1, 256
          cstr(j)(i:i) = ' '
        enddo
      enddo

      ! Break cVars into an array of strings delimited by spaces
      nstr = 0
      istr = 0
      do i = 1, 256
        if(cVars(i:i) .eq. ' ') then
          istr = 0
        else
          if(istr .eq. 0) nstr = nstr + 1
          istr = istr + 1
          cstr(nstr)(istr:istr) = cVars(i:i)
        endif
      enddo
      
      ! Get data fields to be read in
      nvar = 0
      do i = 1, nstr
        do j=1,ndvar
          if(cstr(i) .eq. cVarSymb(j)) then
            nvar = nvar + 1
            ivar(nvar) = j
           endif
        enddo
      enddo

      return
      end
C=====================================================================72
