
#include "StdAfx.h"

#include <sys/timeb.h>
#include <GL/glx.h>
#include <GL/gl.h>
//#include <GL/glxtokens.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <math.h>
#include <pthread.h>

static  int  attributeListSgl[]  =  { GLX_RGBA,
      GLX_RED_SIZE, 1, GLX_GREEN_SIZE, 1, GLX_BLUE_SIZE, 1, None };

static  int  attributeListDbl[] = { GLX_RGBA, GLX_DOUBLEBUFFER,
       GLX_RED_SIZE, 1, GLX_GREEN_SIZE, 1, GLX_BLUE_SIZE, 1, None };

static Bool WaitForNotify(Display *d, XEvent *e, char *arg)
{
	return (e->type == MapNotify) && (e->xmap.window == (Window)arg);
}

int main(int argc, char **argv)
{
	Display *dpy;
	XVisualInfo *vi;
	Colormap cmap;
	XSetWindowAttributes swa;
	Window win;
	GLXContext cx;
	XEvent event;
	int swap_flag = FALSE;
        int iMajorVersion=0, iMinorVersion=0;
        unsigned int iWidth=1024, iHeight=512;

	dpy = XOpenDisplay(0);
	if(dpy == NULL) {
		printf("Could not XOpenDisplay(0)\n");
		return 0;
	}

	glXQueryVersion(dpy, &iMajorVersion, &iMinorVersion);
        printf("XGL Version: %d.%d\n", iMajorVersion, iMinorVersion);

//	vi = glXChooseVisual(dpy, DefaultScreen(dpy), attributeListSgl);
//	if (vi == NULL) {
//		printf("could not glXChooseVizual single buffered\n");
//		return 0;
//	}

	vi = glXChooseVisual(dpy, DefaultScreen(dpy), attributeListDbl);
	swap_flag = TRUE;
	if (vi == NULL) {
		printf("could not glXChooseVizual double buffered\n");
		return 0;
	}

	cx = glXCreateContext(dpy, vi, 0, GL_TRUE);

	cmap   =    XCreateColormap(dpy, RootWindow(dpy, vi->screen),
                                    vi->visual, AllocNone);

	swa.colormap = cmap;
	swa.border_pixel = 0;
	swa.event_mask = StructureNotifyMask;
	win  =  XCreateWindow(dpy,  RootWindow(dpy, vi->screen), 0, 0, iWidth,
                              iHeight, 0, vi->depth, InputOutput, vi->visual,
                              CWBorderPixel|CWColormap|CWEventMask, &swa);
	XMapWindow(dpy, win);
	XIfEvent(dpy, &event, WaitForNotify, (char*)win);

	glXMakeCurrent(dpy, win, cx);

	glClearColor(0,0.5,0,1);
	glClear(GL_COLOR_BUFFER_BIT);
	glFlush();
	if (swap_flag) glXSwapBuffers(dpy,win);

	sleep(10);
	return 0;
}
