////////////////////////////////////////////////////////////////////////////////
//
// Author:   David H. Porter
//           Laboratory for Computational Science & Engineering
//           University of Minnesota
//
////////////////////////////////////////////////////////////////////////////////
/***************************************************************************************
Program:  HVR_SERVER  --  Hierarchical Volume Rendering Component Object Moduel
Copyright (C) 2002  David H. Porter

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
***************************************************************************************/

#include "StdAfx.h"
// #include <windows.h>

/* transpose given xyz cube to yzx or zxy cube */

void TposeYZ( unsigned char *a1, unsigned char *a2, int *nx,  int *ny,  int *nz,
													int *nx1, int *ny1, int *nz1 )
{
	//    xyz -> yzx : view is in x-direction
	int ix, iy, iz, iout, nx2, nx3, nx4, in0, in1, in2, in3;

	nx2 = *nx * 2;
	nx3 = *nx * 3;
	nx4 = *nx * 4;
	for(iz=0; iz< *nz1; iz++) {
		for(ix=0; ix< *nx1; ix++) {
			in0 = *ny * (iz + *nz * ix);
			in1 = in0 + 1;
			in2 = in0 + 2;
			in3 = in0 + 3;
			iout = ix + *nx * *ny * iz;
			for(iy=0; iy< *ny1; iy += 4) {
				a2[iy + in0] = a1[iout      ];
				a2[iy + in1] = a1[iout + *nx];
				a2[iy + in2] = a1[iout + nx2];
				a2[iy + in3] = a1[iout + nx3];
				iout += nx4;
			}
		}
	}
/*
	for(ix=0; ix< *nx1; ix++) {
	for(iz=0; iz< *nz1; iz++) {    in   =      *ny * (iz + *nz * ix);
	for(iy=0; iy< *ny1; iy += 4) { iout = ix + *nx * (iy + *ny * iz);
		a2[iy   + in] = a1[iout        ];
		a2[iy+1 + in] = a1[iout + *nx    ];
		a2[iy+2 + in] = a1[iout + *nx * 2];
		a2[iy+3 + in] = a1[iout + *nx * 3];
	}}}
*/
	return;
}

void TposeXZ( unsigned char *a1, unsigned char *a2, int nx2, int ny2, int nz2, int nx, int ny, int nz )
{
	//    xyz -> xzy : view is in y-direction
	int ix, iy, iz, in0, in1, in2, in3, iout0, iout1, iout2, iout3;

	for(iz=0; iz< nz; iz++) {
	for(iy=0; iy< ny; iy += 4) {

		in0   = nx2 * (iz + nz2 *  iy   );
		in1   = nx2 * (iz + nz2 * (iy+1));
		in2   = nx2 * (iz + nz2 * (iy+2));
		in3   = nx2 * (iz + nz2 * (iy+3));

		iout0 = nx2 * (iy   + ny2 * iz);
		iout1 = nx2 * (iy+1 + ny2 * iz);
		iout2 = nx2 * (iy+2 + ny2 * iz);
		iout3 = nx2 * (iy+3 + ny2 * iz);
/*
		memcpy(&a2[in0], &a1[iout0], (SIZE_T)*nx);
		memcpy(&a2[in1], &a1[iout1], (SIZE_T)*nx);
		memcpy(&a2[in2], &a1[iout2], (SIZE_T)*nx);
		memcpy(&a2[in3], &a1[iout3], (SIZE_T)*nx);
*/

		for(ix=0; ix<nx; ix++) {
			a2[ix  + in0] = a1[ix + iout0];
			a2[ix  + in1] = a1[ix + iout1];
			a2[ix  + in2] = a1[ix + iout2];
			a2[ix  + in3] = a1[ix + iout3];
		}

	}}
	return;
}
